﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_switch_rows_columns
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // The data (from http://www.pangloss.com/seidel/shake_rule.html).
        private string all =
@"artless             base-court          apple-john
bawdy               bat-fowling         baggage
beslubbering        beef-witted         barnacle
bootless            beetle-headed       bladder
churlish            boil-brained        boar-pig
cockered            clapper-clawed      bugbear
clouted             clay-brained        bum-bailey
craven              common-kissing      canker-blossom
currish             crook-pated         clack-dish
dankish             dismal-dreaming     clotpole
dissembling         dizzy-eyed          coxcomb
droning             doghearted          codpiece
errant              dread-bolted        death-token
fawning             earth-vexing        dewberry
fobbing             elf-skinned         flap-dragon
froward             fat-kidneyed        flax-wench
frothy              fen-sucked          flirt-gill
gleeking            flap-mouthed        foot-licker
goatish             fly-bitten          fustilarian
gorbellied          folly-fallen        giglet
impertinent         fool-born           gudgeon
infectious          full-gorged         haggard
jarring             guts-griping        harpy
loggerheaded        half-faced          hedge-pig
lumpish             hasty-witted        horn-beast
mammering           hedge-born          hugger-mugger
mangled             hell-hated          joithead
mewling             idle-headed         lewdster
paunchy             ill-breeding        lout
pribbling           ill-nurtured        maggot-pie
puking              knotty-pated        malt-worm
puny                milk-livered        mammet
qualling            motley-minded       measle
rank                onion-eyed          minnow
reeky               plume-plucked       miscreant
roguish             pottle-deep         moldwarp
ruttish             pox-marked          mumble-news
saucy               reeling-ripe        nut-hook
spleeny             rough-hewn          pigeon-egg
spongy              rude-growing        pignut
surly               rump-fed            puttock
tottering           shard-borne         pumpion
unmuzzled           sheep-biting        ratsbane
vain                spur-galled         scut
venomed             swag-bellied        skainsmate
villainous          tardy-gaited        strumpet
warped              tickle-brained      varlot
wayward             toad-spotted        vassal
weedy               unchin-snouted      whey-face
yeasty              weather-bitten      wagtail";

        // Switch rows and columns.
        private void btnSwitch_Click(object sender, EventArgs e)
        {
            // Split the data into lines.
            string[] newline = { "\r\n" };
            string[] lines = all.Split(newline,
                StringSplitOptions.RemoveEmptyEntries);

            // Split the lines into words.
            int num_rows = lines.Length;
            int num_cols = 3;
            string[,] words = new string[num_rows, num_cols];
            for (int row = 0; row < num_rows; row++)
            {
                string[] space = { " " };
                string[] line_words = lines[row].Split(space,
                    StringSplitOptions.RemoveEmptyEntries);
                for (int col = 0; col < num_cols; col++)
                {
                    words[row, col] = line_words[col];
                }
            }

            // Generate the output.
            string result = "";
            for (int col = 0; col < num_cols; col++)
            {
                result += "        private string[] Column" +
                    col.ToString() + " =\r\n";
                result += "        {\r\n";
                for (int row = 0; row < num_rows; row++)
                {
                    result += "            \"" + words[row, col] + "\",\r\n";
                }
                result += "        };\r\n\r\n";
            }

            // Display the result.
            txtResult.Text = result;
        }
    }
}
